#include <iostream>
#include <list>
#include <vector>
#include <algorithm>
#include <functional>
using namespace std;

int main()
{
    list<int> menge1;

    /* Elemente 9 bis 1 und 1 bis 9 in die erste Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge1.push_front(i);    // vorne absteigend
        menge1.push_back(i);     // hinten aufsteigend
    }

    /* die erste Menge ausgeben
     */
    copy (menge1.begin(), menge1.end(),
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* die Elemente sortiert in eine zweite Menge kopieren
     */
    vector<int> menge2(100);    // mit 100 Elementen angelegt
    vector<int>::iterator pos2;
    pos2 = partial_sort_copy (menge1.begin(), menge1.end(),
                              menge2.begin(), menge2.end());

    /* sortierte Kopie ausgeben
     *  - Ziel-Menge ist gross genug => alle sortiert kopieren
     */
    copy (menge2.begin(), pos2,
          ostream_iterator<int>(cout," "));
    cout << endl;

    /* die Elemente umgekehrt sortiert in eine dritte Menge kopieren
     *  - Ziel-Menge ist kleiner => nicht alle sortiert kopieren
     */
    vector<int> menge3(10);    // mit 10 Elementen angelegt
    vector<int>::iterator pos3;
    pos3 = partial_sort_copy (menge1.begin(), menge1.end(),
                              menge3.begin(), menge3.end(),
                              greater<int>());

    /* sortierte Kopie ausgeben
     */
    copy (menge3.begin(), pos3,
          ostream_iterator<int>(cout," "));
    cout << endl;
}
