#include <iostream>
#include <vector>
#include <list>
#include <algorithm>
#include <functional>
#include "PRINT.h"
using namespace std;

int main()
{
    vector<int> menge1;
    list<int> menge2;

    /* Elemente 1 bis 9 in die erste Menge einfuegen
     */
    for (int i=1; i<=9; i++) {
        menge1.push_back(i);
    }
    PRINT ("menge1:       ", menge1);

    /* Elemente in der Menge negieren
     */
    transform (menge1.begin(), menge1.end(),   // Quellbereich
               menge1.begin(),                 // Zielbereich
               negate<int>());                 // Operation
    PRINT ("negiert:      ", menge1);

    /* Elemente verzehnfacht in die zweite Menge einfuegen
     *  - frueher "times" statt "multiplies"
     */
    transform (menge1.begin(), menge1.end(),   // Quellbereich
               back_inserter(menge2),          // Zielbereich
               bind2nd(multiplies<int>(),10)); // Operation
    PRINT ("verzehnfacht: ", menge2);

    /* beide Mengen rueckwaerts und negiert ausgeben
     */
    transform (menge1.rbegin(), menge1.rend(),
               ostream_iterator<int>(cout," "),
               negate<int>());
    cout << endl;
    transform (menge2.rbegin(), menge2.rend(),
               ostream_iterator<int>(cout," "),
               negate<int>());
    cout << endl;
}
