#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

/* Klasse fuer Funktionsobjekte, die den Mittelwert bilden
 */
class Mittelwert {
  private:
    int anz;    // Anzahl aller Elemente
    int sum;    // Summe der Werte aller Elemente
  public:
    // Konstruktor
    Mittelwert () : anz(0), sum(0) {
    }

    // Element aufnehmen
    void operator() (int elem) {
        anz++;
        sum += elem;
    }

    // Mittelwert liefern
    float wert () {
        return static_cast<float>(sum) / static_cast<float>(anz);
    }
};

int main()
{
    vector<int> menge;

    /* Elemente 1 bis 6 in die Menge einfuegen
     */
    for (int i=1; i<=6; i++) {
        menge.push_back(i);
    }

    /* Mittelwert bilden und ausgeben
     */
    Mittelwert mw = for_each (menge.begin(), menge.end(), Mittelwert());
    cout << "Mittelwert: " << mw.wert() << endl;
}
