void printIntPtr (Ptr<int> elem)
{
    cout << *elem << ' ';
}

int main()
{
    /* Array von Integer-Werten
     */
    static int werte[] = { 3, 5, 2, 1, 6, 4 };

    typedef Ptr<int> IntPtr;

    /* zwei unterschiedliche Mengen
     */
    list<IntPtr> menge1;
    deque<IntPtr> menge2;

    /* Zeiger auf Elemente in beide Mengen einfuegen
     *  - in menge1 vorwaerts
     *  - in menge2 rueckwaerts
     */
    for (int i=0; i<sizeof(werte)/sizeof(werte[0]); i++) {
        menge1.push_back(IntPtr(werte[i]));
        menge2.push_front(IntPtr(werte[i]));
    }

    /* beide Mengen ausgeben
     */
    for_each (menge1.begin(), menge1.end(), printIntPtr);
    cout << endl;
    for_each (menge2.begin(), menge2.end(), printIntPtr);
    cout << endl;

    /* zweiten und sechsten Wert der Elemente quadrieren
     */
    werte[1] *= werte[1];
    werte[5] *= werte[5];

    /* Wert vom ersten Element in der ersten Menge erhoehen
     */
    (**menge1.begin()) += 100;

    /* beide Mengen wieder ausgeben
     */
    for_each (menge1.begin(), menge1.end(), printIntPtr);
    cout << endl;
    for_each (menge2.begin(), menge2.end(), printIntPtr);
    cout << endl;

    /* Elemente in der zweiten Menge sortieren
     */
    sort (menge2.begin(), menge2.end());

    /* beide Mengen wieder ausgeben
     */
    for_each (menge1.begin(), menge1.end(), printIntPtr);
    cout << endl;
    for_each (menge2.begin(), menge2.end(), printIntPtr);
    cout << endl;
}
