#include <string>
#include <iostream>
#include <algorithm>
using namespace std;

int main()
{
    /* String-Konstante hallo anlegen
     */
    const string hallo("Hallo, geht es?");

    /* String s mit allen Zeichen von String hallo initialisieren
     */
    string s(hallo.begin(),hallo.end());

    /* alle Zeichen von s vorwaerts ausgeben
     */
    string::iterator pos;
    for (pos = s.begin(); pos != s.end(); ++pos) {
        cout << *pos;
    }
    cout << endl;

    /* Reihenfolge aller Zeichen von s umkehren
     *  - verwendet Algorithmus reverse()
     */
    reverse (s.begin(), s.end());
    cout << "umgedreht:      " << s << endl;

    /* alle Zeichen von s sortieren
     *  - verwendet Algorithmus sort()
     */
    sort (s.begin(), s.end());
    cout << "sortiert:       " << s << endl;

    /* alle aufeinanderfolgenden Duplikate von s entfernen
     *  - Algorithmus unique() liefert neues Ende
     *  - Elementfunktion erase() verkleinert entsprechend
     */
    s.erase (unique(s.begin(),s.end()), s.end());
    cout << "ohne Duplikate: " << s << endl;

    /* Die ersten 3 Zeichen von s durch
     * alle Zeichen von hallo bis vor ' ' ersetzen
     *  - Algorithmus find() liefert Position von ' '
     *  - Elementfunktion replace() ersetzt entsprechend
     */
    s.replace (s.begin(), s.begin()+3,
               hallo.begin(), find(hallo.begin(),hallo.end(),' '));
    cout << "ersetzt:        " << s << endl;
}
